/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements. See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the  "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#if !defined(XPATHINIT_INCLUDE_GUARD_1357924680)
#define XPATHINIT_INCLUDE_GUARD_1357924680



// Base include file.  Must be first.
#include <xalanc/XPath/XPathDefinitions.hpp>



#include <xalanc/PlatformSupport/PlatformSupportInit.hpp>



#include <xalanc/DOMSupport/DOMSupportInit.hpp>



namespace XALAN_CPP_NAMESPACE {



class XALAN_XPATH_EXPORT XPathInit
{
public:

    explicit
    XPathInit(MemoryManager& theManager XALAN_DEFAULT_MEMMGR);

    static XPathInit*
    create(MemoryManager& theManager);

    ~XPathInit();

private:

    // Not implemented...
    XPathInit(const XPathInit&);

    XPathInit&
    operator=(const XPathInit&);

    
    static void
    initialize(MemoryManager& theManager);

    static void
    terminate();

    const PlatformSupportInit   m_platformSupportInit;

    const DOMSupportInit        m_domSupportInit;

    static unsigned long        s_initCounter;
};



}



#endif  // !defined(XPATHINIT_INCLUDE_GUARD_1357924680)
